<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" @ok="handleSubmit" :closeFunc="handlerCloseFunc">
      <MerticCheckbox :actCheckbox="actCheckbox" />
      <BasicForm v-show="false" @register="registerForm"/>
  </BasicModal>
</template>

<script lang="ts" setup>
import { message } from 'ant-design-vue';
import { computed, ref, unref } from 'vue';
import MerticCheckbox from '../../components/MerticCheckbox.vue';
import { saveOrUpdateRef } from '../StMetric.api';
import { formSchema } from '../StMetric.data';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BasicModal, useModalInner } from '/@/components/Modal';
    // Emits声明
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);
    const actCheckbox = ref({});
    const caNo = ref('');
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        caNo.value = data?.caNo;
        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
        }
        actCheckbox.value = {}
        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    const title = computed(() => (!unref(isUpdate) ? '新增' : '修改'));
    function handlerCloseFunc(){
        actCheckbox.value = {}
        return new Promise((res,rej)=>{res(true)})
    }
    //表单提交事件
    async function handleSubmit(v) {
        try {
            let values = {}//await validate();
            setModalProps({confirmLoading: true});
            if(!caNo.value){
                message.error("控制活动不存在，请检查")
                return;
            }
            values['caNo'] = caNo.value;
            let metricNos = []
             for(let key in actCheckbox.value){
                if(actCheckbox.value[key]){
                    metricNos.push(key)
                }
             }
             if(!metricNos || metricNos.length==0){
                message.error("请选择度量指标!")
                return;
            }
             values['metricNos'] = metricNos;
            //提交表单
            await saveOrUpdateRef(values, isUpdate.value);
            //关闭弹窗
            closeModal();
            //刷新列表
            emit('success');
        } finally {
            setModalProps({confirmLoading: false});
        }
    }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>